#include "isxdl.iss"

[Setup]
AppName=Aran
AppVerName=Aran 1.0
AppCopyright=Copyright  2008 Abel Garca Plaza
VersionInfoVersion=1.0
VersionInfoTextVersion=1.0
VersionInfoCompany=Abel Garca Plaza
VersionInfoDescription=Aran, an XNA-compliant .NET automated planning framework
VersionInfoCopyright=Copyright  2008 Abel Garca Plaza
WizardImageFile=AranWizardImage.bmp
WizardSmallImageFile=AranWizardSmallImage.bmp
SetupIconFile=Aran.ico
UninstallDisplayIcon={app}\Aran.ico
OutputBaseFilename=AranSetup
PrivilegesRequired=admin
SourceDir=.
OutputDir=setup
Uninstallable=true
ShowLanguageDialog=no
WindowVisible=false
WindowResizable=false
CreateAppDir=true
DefaultDirName={pf}\Aran
DefaultGroupName=Aran
LicenseFile=License.rtf
ChangesEnvironment=true
MinVersion=0,5.0.2195
UninstallFilesDir={app}\v1.0

[_ISTool]
EnableISX=true

[Tasks]
Name: PublishCommand; Description: Make Aran command available from prompt

[Files]
;image files
Source: AranWizardSmallImage.bmp; DestDir: {tmp}; Flags: dontcopy
Source: Aran.ico; DestDir: {app}\v1.0
Source: Help.ico; DestDir: {app}\v1.0
Source: Uninstall.ico; DestDir: {app}\v1.0
;documentation files
Source: PC\doc\Aran.chm; DestDir: {app}\v1.0
;PC files
Source: PC\Core\bin\Aran.Core.dll; DestDir: {app}\v1.0\PC
Source: PC\Functional\bin\Aran.Functional.dll; DestDir: {app}\v1.0\PC
Source: PC\Planning.Xml\bin\Aran.Planning.Xml.dll; DestDir: {app}\v1.0\PC
Source: PC\Planning.Xml.Command\bin\aran.exe; DestDir: {app}\v1.0\PC
Source: PC\Representation\bin\Aran.Representation.dll; DestDir: {app}\v1.0\PC
Source: PC\Representation.Xml\bin\Aran.Representation.Xml.dll; DestDir: {app}\v1.0\PC
Source: PC\Searching\bin\Aran.Searching.dll; DestDir: {app}\v1.0\PC
Source: PC\Searching.Specialized\bin\Aran.Searching.Specialized.dll; DestDir: {app}\v1.0\PC
Source: PC\Translation\bin\Aran.Translation.dll; DestDir: {app}\v1.0\PC
;PC IntelliSense files
Source: PC\Core\bin\Aran.Core.xml; DestDir: {app}\v1.0\PC
Source: PC\Functional\bin\Aran.Functional.xml; DestDir: {app}\v1.0\PC
Source: PC\Planning.Xml\bin\Aran.Planning.Xml.xml; DestDir: {app}\v1.0\PC
Source: PC\Representation\bin\Aran.Representation.xml; DestDir: {app}\v1.0\PC
Source: PC\Representation.Xml\bin\Aran.Representation.Xml.xml; DestDir: {app}\v1.0\PC
Source: PC\Searching\bin\Aran.Searching.xml; DestDir: {app}\v1.0\PC
Source: PC\Searching.Specialized\bin\Aran.Searching.Specialized.xml; DestDir: {app}\v1.0\PC
Source: PC\Translation\bin\Aran.Translation.xml; DestDir: {app}\v1.0\PC
;PC neutral Spanish resource files
Source: PC\Planning.Xml\bin\es\Aran.Planning.Xml.resources.dll; DestDir: {app}\v1.0\PC\es
Source: PC\Planning.Xml.Command\bin\es\aran.resources.dll; DestDir: {app}\v1.0\PC\es
Source: PC\Representation\bin\es\Aran.Representation.resources.dll; DestDir: {app}\v1.0\PC\es
Source: PC\Representation.Xml\bin\es\Aran.Representation.Xml.resources.dll; DestDir: {app}\v1.0\PC\es
Source: PC\Searching\bin\es\Aran.Searching.resources.dll; DestDir: {app}\v1.0\PC\es
Source: PC\Translation\bin\es\Aran.Translation.resources.dll; DestDir: {app}\v1.0\PC\es
;Xbox360 files
Source: Xbox360\Core\bin\Aran.Core.dll; DestDir: {app}\v1.0\Xbox360
Source: Xbox360\Functional\bin\Aran.Functional.dll; DestDir: {app}\v1.0\Xbox360
Source: Xbox360\Planning.Xml\bin\Aran.Planning.Xml.dll; DestDir: {app}\v1.0\Xbox360
Source: Xbox360\Representation\bin\Aran.Representation.dll; DestDir: {app}\v1.0\Xbox360
Source: Xbox360\Representation.Xml\bin\Aran.Representation.Xml.dll; DestDir: {app}\v1.0\Xbox360
Source: Xbox360\Searching\bin\Aran.Searching.dll; DestDir: {app}\v1.0\Xbox360
Source: Xbox360\Searching.Specialized\bin\Aran.Searching.Specialized.dll; DestDir: {app}\v1.0\Xbox360
Source: Xbox360\Translation\bin\Aran.Translation.dll; DestDir: {app}\v1.0\Xbox360
;Xbox360 IntelliSense files
Source: Xbox360\Core\bin\Aran.Core.xml; DestDir: {app}\v1.0\Xbox360
Source: Xbox360\Functional\bin\Aran.Functional.xml; DestDir: {app}\v1.0\Xbox360
Source: Xbox360\Planning.Xml\bin\Aran.Planning.Xml.xml; DestDir: {app}\v1.0\Xbox360
Source: Xbox360\Representation\bin\Aran.Representation.xml; DestDir: {app}\v1.0\Xbox360
Source: Xbox360\Representation.Xml\bin\Aran.Representation.Xml.xml; DestDir: {app}\v1.0\Xbox360
Source: Xbox360\Searching\bin\Aran.Searching.xml; DestDir: {app}\v1.0\Xbox360
Source: Xbox360\Searching.Specialized\bin\Aran.Searching.Specialized.xml; DestDir: {app}\v1.0\Xbox360
Source: Xbox360\Translation\bin\Aran.Translation.xml; DestDir: {app}\v1.0\Xbox360
;Xbox360 neutral Spanish resource files
Source: Xbox360\Planning.Xml\bin\es\Aran.Planning.Xml.resources.dll; DestDir: {app}\v1.0\Xbox360\es
Source: Xbox360\Representation\bin\es\Aran.Representation.resources.dll; DestDir: {app}\v1.0\Xbox360\es
Source: Xbox360\Representation.Xml\bin\es\Aran.Representation.Xml.resources.dll; DestDir: {app}\v1.0\Xbox360\es
Source: Xbox360\Searching\bin\es\Aran.Searching.resources.dll; DestDir: {app}\v1.0\Xbox360\es
Source: Xbox360\Translation\bin\es\Aran.Translation.resources.dll; DestDir: {app}\v1.0\Xbox360\es

[Icons]
Name: {group}\v1.0\Documentation; Filename: {app}\v1.0\Aran.chm; Comment: View Aran documentation; IconFilename: {app}\v1.0\Help.ico
Name: {group}\v1.0\Web site; Filename: http://www.codeplex.com/Aran; Comment: Go to Aran web site; IconFilename: {app}\v1.0\Aran.ico
Name: {group}\v1.0\Uninstall; Filename: {app}\v1.0\unins000.exe; WorkingDir: {app}\v1.0; Comment: Uninstall Aran; IconFilename: {app}\v1.0\Uninstall.ico

[Registry]
Root: HKLM; Subkey: SOFTWARE\Microsoft\.NETFramework\v2.0.50727\AssemblyFoldersEx\Aran 1.0; ValueType: string; ValueData: {app}\v1.0\PC; Flags: uninsdeletekey
Root: HKLM; Subkey: SOFTWARE\Microsoft\XNA\AssemblyFolders\v2.0\Xbox 360\AssemblyFoldersEx\Aran 1.0; ValueType: string; ValueData: {app}\v1.0\Xbox360; Flags: uninsdeletekey

[Run]
Filename: {ini:{tmp}\dependencies.ini,install,dotnetfx}; Parameters: "/q:a /t:{tmp}\dotnetfx /C:""install /q"""; Flags: skipifdoesntexist

[UninstallDelete]
Name: {app}\v1.0; Type: filesandordirs
Name: {app}; Type: dirifempty

[Code]
const
	//Command publishing constants
	CommandDirectory = '{app}\v1.0\PC';
	PathSeparator = ';';
	PathSeparatorLength = 1;
	EnvironmentRegKey = 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment';
	PathRegValue = 'Path';
	//.NET Framework download constants
	DotNetFrameworkRegKey = 'Software\Microsoft\.NETFramework\policy\v2.0';
	DotNetFrameworkUrl = 'http://download.microsoft.com/download/5/6/7/567758a3-759e-473e-bf8f-52154438565a/dotnetfx.exe';

procedure SetDownloadFormSmallImage();
var
	WizardSmallImagePath: String;
begin
	WizardSmallImagePath := 'AranWizardSmallImage.bmp';
	ExtractTemporaryFile(WizardSmallImagePath);
	WizardSmallImagePath := ExpandConstant('{tmp}\' + WizardSmallImagePath);
	isxdl_SetOption('smallwizardimage', WizardSmallImagePath);
end;

procedure AddDotNetFrameworkToDependenciesList();
var
	DotNetFrameworkPath: String;
begin
	DotNetFrameworkPath := ExtractFileDrive(ExpandConstant('{src}')) + '\dependencies\dotnetfx.exe';
	if not FileExists(DotNetFrameworkPath) then begin
		DotNetFrameworkPath := ExpandConstant('{tmp}\dotnetfx.exe');
		if not FileExists(DotNetFrameworkPath) then begin
			isxdl_AddFile(DotNetFrameworkUrl, DotNetFrameworkPath);
		end;
	end;
	SetIniString('install', 'dotnetfx', DotNetFrameworkPath, ExpandConstant('{tmp}\dependencies.ini'));
end;

function NextButtonClick(CurPage: Integer): Boolean;
var
	IsDotNetFrameworkInstalled: boolean;
	WizardHandler: integer;
begin
	Result := true;
	if CurPage = wpLicense then begin
		IsDotNetFrameworkInstalled := RegKeyExists(HKLM, DotNetFrameworkRegKey);
		if not IsDotNetFrameworkInstalled then begin
			SetDownloadFormSmallImage();
			AddDotNetFrameworkToDependenciesList();
			WizardHandler := StrToInt(ExpandConstant('{wizardhwnd}'));
			Result := (isxdl_DownloadFiles(WizardHandler) <> 0);
		end;
	end;
end;

function RemovePathFromList(const PathList, PathToRemove: string): string;
var
	CurrentPath: string;
	RemainingPaths: string;
	PathSeparatorPosition: integer;
begin
	Result := '';
	RemainingPaths := PathList + PathSeparator;
	PathSeparatorPosition := Pos(PathSeparator, RemainingPaths);
	while PathSeparatorPosition > 0 do begin
		CurrentPath := Copy(RemainingPaths, 0, PathSeparatorPosition - 1);
		if CurrentPath <> PathToRemove then begin
			if Length(Result) = 0 then begin
				Result := CurrentPath;
			end else begin
				Result := Result + PathSeparator + CurrentPath;
			end;
		end;
		RemainingPaths := Copy(RemainingPaths, PathSeparatorPosition + PathSeparatorLength,
			Length(RemainingPaths) - PathSeparatorPosition - PathSeparatorLength);
		PathSeparatorPosition := Pos(PathSeparator, RemainingPaths);
	end;
end;

function InsertPathFirstIntoList(const PathList, PathToAdd: string): string;
begin
	RemovePathFromList(PathList, PathToAdd);
	if Length(PathList) > 0 then begin
		Result := PathToAdd + PathSeparator + PathList;
	end else begin
		Result := PathToAdd;
	end;
end;

procedure CurStepChanged(CurStep: TSetupStep);
var
	Paths: string;
begin
	if (CurStep = ssPostInstall) and IsTaskSelected('PublishCommand') then begin
		RegQueryStringValue(HKEY_LOCAL_MACHINE, EnvironmentRegKey, PathRegValue, Paths);
		Paths := InsertPathFirstIntoList(Paths, ExpandConstant(CommandDirectory));
		RegWriteStringValue(HKEY_LOCAL_MACHINE, EnvironmentRegKey, PathRegValue, Paths);
	end;
end;

procedure CurUninstallStepChanged(CurUninstallStep: TUninstallStep);
var
	Paths: string;
begin
	if CurUninstallStep = usUninstall then begin
		RegQueryStringValue(HKEY_LOCAL_MACHINE, EnvironmentRegKey, PathRegValue, Paths);
		Paths := RemovePathFromList(Paths, ExpandConstant(CommandDirectory));
		RegWriteStringValue(HKEY_LOCAL_MACHINE, EnvironmentRegKey, PathRegValue, Paths);
	end;
end;
